package com.unfpa.climatequizgame.setting;

import com.unfpa.climatequizgame.model.*;
import com.unfpa.climatequizgame.service.QuestionService;
import com.unfpa.climatequizgame.service.ResponseService;
import com.unfpa.climatequizgame.service.UserService;
import jakarta.annotation.PostConstruct;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Optional;

@Component
public class InitializerAccessData {

    private final UserService userService;
    private final QuestionService questionService;
    private final ResponseService responseService;

    public InitializerAccessData(UserService userService, QuestionService questionService, ResponseService responseService) {
        this.userService = userService;
        this.questionService = questionService;
        this.responseService = responseService;
    }

    @PostConstruct
    private void postConstruct() {
        initializeUser();
        initializeQuestionResponse();
    }

    /**
     * initialize users
     */
    private void initializeUser()
    {
        Optional<User> admin = userService.getUserByLoginName("admin");

        if(admin.isEmpty())
        {
            // admin
            User admin1 = new User();
            admin1.setLoginName("admin");
            admin1.setPassword("1234");
            admin1.setRole(Role.ADMIN);
            userService.saveUser(admin1);
            // user 1
            User user1 = new User();
            user1.setLoginName("user1");
            user1.setPassword("1234");
            user1.setRole(Role.USER);
            userService.saveUser(user1);
            // user 2
            User user2 = new User();
            user2.setLoginName("user2");
            user2.setPassword("1234");
            user2.setRole(Role.USER);
            userService.saveUser(user2);
        }

    }

    /**
     * initialize question
     */
    private void initializeQuestionResponse(){
        if(this.questionService.getAllQuestion().isEmpty()){
            // first round
            String[] arrayQuestion = {"What is the COP28 ?", "Climate is: ", "Which of the following is a greenhouse gas (GHG) ?",
                    "What percentage of the global greenhouse gas emissions does the transportation sector emit ?", "Which of these countries emits the most carbon dioxide ?",
                    "Globally, which of the following economic sectors emits the largest percentage of greenhouse gas emissions","What is the greenhouse effect ?",
                    "What can we do to help fight climate change ?","The overwhelming majority of scientists agree that climate change is real and caused by humans.",
                    "Wasting less food is a way to reduce greenhouse gas emissions","Which years have been the hottest on record ?",
                    "Individual consumer carbon footprint is the total amount of greenhouse gasses generated by our actions. What are ways an individual can reduce their footprint ?",
                    "What do male condoms offer that other contraceptive methods do not?","True or false: A girl can get pregnant the first time she has sex.",
                    "Oral contraceptives are very safe for young women.","Oral contraceptives offer protection against some STIs.",
                    "Young people can safely use injectables and implants.","Traditional methods offer no protection against STIs.",
                    "Dual protection refers to","emergency contraception can be used to prevent pregnancy After unprotected intercourse.",
                    "emergency contraception can be used to prevent pregnancy As a regular method.","Sex education leads to earlier or increased sexual activity."};

            String[] arrayResponses1 ={"28th Cooperation of the Partnership","28th Conference of the Parties","28th Climate Opportunity for Partnership"};
            String[] arrayResponses2 ={"Climate is the average weather in a given area over a longer period of time",
                    "Climate is defined by today's weather, whether it's hot or rainy","Climate is earth’s temperature rising"};
            String[] arrayResponses3 ={"CO2","CH4","ALL ABOVE"};
            String[] arrayResponses4 ={"1%","20%","33%","70%"};
            String[] arrayResponses5 ={"USA","Russia","UK","CHINA"};
            String[] arrayResponses6 ={"Residential","Transportation","Industry","Electric power"};
            String[] arrayResponses7 ={"When the sun's rays become very strong and have an impact on the climate ",
                    "When the gasses in our atmosphere trap heat and block it from escaping our planet","When you build a greenhouse"};
            String[] arrayResponses8 ={"Utilize public transit","Consume less meet products",
                    "Vote for political candidates who will advocate for climate-related legislation and policy improvements",
                "All of the above"};
            String[] arrayResponses9 ={"True","False"};
            String[] arrayResponses10 ={"True","False"};
            String[] arrayResponses11 ={"2016–2020","2010–2015","2000-2005"};
            String[] arrayResponses12 ={"Change to a plant-based diet","Walk, bike or take public transportation",
                    "Use less air conditioning and heating in the home","All of the above"};
            String[] arrayResponses13 ={"Least chance of failure","Best protection against STIs","Cheapest to use","All of the above"};
            String[] arrayResponses14 ={"TRUE","FALSE"};
            String[] arrayResponses15 ={"TRUE","FALSE"};
            String[] arrayResponses16 ={"TRUE","FALSE"};
            String[] arrayResponses17 ={"TRUE","FALSE"};
            String[] arrayResponses18 ={"TRUE","FALSE"};
            String[] arrayResponses19 ={"Use of a highly effective contraceptive method for pregnancy prevention along with condoms for STI prevention.","Use of condoms to prevent pregnancy and STI transmission.","Choices a and b.","None of the above."};
            String[] arrayResponses20 ={"TRUE","FALSE"};
            String[] arrayResponses21 ={"TRUE","FALSE"};
            String[] arrayResponses22 ={"TRUE","FALSE"};

            int i = 0;
            for(String s : arrayQuestion) {
                Question q = new Question();
                q.setQuestion(s);
                q.setCategory(CategoryGame.FIRST_ROUND);
                Question qs = this.questionService.saveOrUpdateQuestion(q);
                if(i == 0){
                    giveResponse(List.of(arrayResponses1),qs,"28th Conference of the Parties","");
                }
                if(i == 1){
                    giveResponse(List.of(arrayResponses2),qs,"Climate is the average weather in a given area over a longer period of time","");
                }
                if(i == 2){
                    giveResponse(List.of(arrayResponses3),qs,"ALL ABOVE","");
                }
                if(i == 3){
                    giveResponse(List.of(arrayResponses4),qs,"20%","Statista https://www.statista.com/topics/7476/transportation-emissions-worldwide/#topicOverview" +
                            "5. Which of these countries emits the mos");
                }
                if(i == 4){
                    giveResponse(List.of(arrayResponses5),qs,"CHINA","https://world101.cfr.org/global-era-issues/climate-change/who-releases-most-greenhouse-gases");
                }
                if(i == 5){
                    giveResponse(List.of(arrayResponses6),qs,"Electric power","https://www.earthday.org/the-climate-change-quiz/");
                }
                if(i == 6){
                    giveResponse(List.of(arrayResponses7),qs,"When the gasses in our atmosphere trap heat and block it from escaping our planet","");
                }
                if(i == 7){
                    giveResponse(List.of(arrayResponses8),qs,"All of the above","");
                }
                if(i == 8){
                    giveResponse(List.of(arrayResponses9),qs,"True","");
                }
                if(i == 9){
                    giveResponse(List.of(arrayResponses10),qs,"True","");
                }
                if(i == 10){
                    giveResponse(List.of(arrayResponses11),qs,"2016–2020","");
                }
                if(i == 11){
                    giveResponse(List.of(arrayResponses12),qs,"All of the above","");
                }
                if(i == 12){
                    giveResponse(List.of(arrayResponses13),qs,"Best protection against STIs","");
                }
                if(i == 13){
                    giveResponse(List.of(arrayResponses14),qs,"TRUE","");
                }
                if(i == 14){
                    giveResponse(List.of(arrayResponses15),qs,"TRUE","");
                }
                if(i == 15){
                    giveResponse(List.of(arrayResponses16),qs,"TRUE","");
                }
                if(i == 16){
                    giveResponse(List.of(arrayResponses17),qs,"TRUE","");
                }
                if(i == 17){
                    giveResponse(List.of(arrayResponses18),qs,"TRUE","");
                }
                if(i == 18){
                    giveResponse(List.of(arrayResponses19),qs,"Choices a and b.","");
                }
                if(i == 19){
                    giveResponse(List.of(arrayResponses20),qs,"TRUE","");
                }
                if(i == 20){
                    giveResponse(List.of(arrayResponses21),qs,"FALSE","");
                }
                if(i == 21){
                    giveResponse(List.of(arrayResponses22),qs,"FALSE","");
                }

                i++;
            }

            // second round
            String[] arrayQuestion2 = {"The United Nations lists 17 Sustainable Development Goals. Which of these is an SDG ?","How do toxic chemicals in plastics enter the human body ?",
                    "What is the estimated global cost of plastic-related health effects per year ?","Which of these countries have vowed to use only 100% renewable energy by 2050 ?",
                    "Which of the following is not considered to be a source of renewable energy ?","Which is one of the fastest growing renewable energy sectors in the world ?",
                    "According to scientists, about how many countries could run entirely on wind, solar and water power by 2050 ?","What percentage of the world’s forests have been destroyed ?",
                    "Carbon dioxide is the most commonly used greenhouse gas.","What percentage of food globally is wasted annually ?",
                    "Which of these methods of sterilization is permanent?","Which type of intrauterine device (IUD) is available?",
                    "Oral contraceptives can protect against ectopic pregnancy, benign breast disease,","Fertility returns ten months to a year after a woman stops taking the pill.",
                    "Natural family planning requires knowledge of reproductive physiology, including","emergency contraception can be used to prevent pregnancy  As a backup method after contraceptive failure.",
                    "Sex education tries to give young people skills to delay sexual activity.","Sex education can lead to increased use of contraceptive."
            };

            String[] arrayResponses23 ={"Zero hunger","Affordable and Clean Energy","Climate Action","All of the above"};
            String[] arrayResponses24 ={"Inhalation","Ingestion","Direct skin contact","All of the above"};
            String[] arrayResponses25 ={"Less than $1 billion","$10 billion","$50 billion","$100 million"};
            String[] arrayResponses26 ={"Afghanistan","Guatemala","Vietnam","Kenya","All of the above"};
            String[] arrayResponses27 ={"Hydropower","Wind","Natural gas","Solar"};
            String[] arrayResponses28 ={"Solar","Biomass","Geothermal","None of the above"};
            String[] arrayResponses29 ={"0","20","70","140"};
            String[] arrayResponses30 ={"28","33","46","54"};
            String[] arrayResponses31 ={"True","False"};
            String[] arrayResponses32 ={"1/3","1/4","1/8","1/5"};
            String[] arrayResponses33 ={"Tubal sterilization","Vasectomy","All of the above","None of the above"};
            String[] arrayResponses34 ={"Copper","Titanium","Hormonal","A and C","All of the above"};
            String[] arrayResponses35 ={"TRUE","FALSE"};
            String[] arrayResponses36 ={"TRUE","FALSE"};
            String[] arrayResponses37 ={"TRUE","FALSE"};
            String[] arrayResponses38 ={"TRUE","FALSE"};
            String[] arrayResponses39 ={"TRUE","FALSE"};
            String[] arrayResponses40 ={"TRUE","FALSE"};

            int j = 0;
            for(String s : arrayQuestion2) {
                Question q = new Question();
                q.setQuestion(s);
                q.setCategory(CategoryGame.SECOND_ROUND);
                Question qs = this.questionService.saveOrUpdateQuestion(q);
                if(j == 0){
                    giveResponse(List.of(arrayResponses23),qs,"All of the above","");
                }
                if(j == 1){
                    giveResponse(List.of(arrayResponses24),qs,"All of the above","");
                }
                if(j == 2){
                    giveResponse(List.of(arrayResponses25),qs,"$100 million",": $100 million in 2022 (https://www.earthday.org/plastics-human-health-quiz/)");
                }
                if(j == 3){
                    giveResponse(List.of(arrayResponses26),qs,"All of the above","Commitment during the United Nations Climate Change Conference (2016) in Marrakesh");
                }
                if(j == 4){
                    giveResponse(List.of(arrayResponses27),qs,"Natural gas","");
                }
                if(j == 5){
                    giveResponse(List.of(arrayResponses28),qs,"Solar","");
                }
                if(j == 6){
                    giveResponse(List.of(arrayResponses29),qs," 140","https://www.earthday.org/the-clean-energy-quiz/  et  https://www.independent.co.uk/climate-change/news/wind-solar-water-power-countries-entirely-powered-2050-renewable-energy-climate-change-fossil-fuels-a7908821.html");
                }
                if(j == 7){
                    giveResponse(List.of(arrayResponses30),qs,"46","");
                }
                if(j == 8){
                    giveResponse(List.of(arrayResponses31),qs,"True","");
                }
                if(j == 9){
                    giveResponse(List.of(arrayResponses32),qs,"1/3","");
                }
                if(j == 10){
                    giveResponse(List.of(arrayResponses33),qs,"All of the above","");
                }
                if(j == 11){
                    giveResponse(List.of(arrayResponses34),qs,"A and C","");
                }
                if(j == 12){
                    giveResponse(List.of(arrayResponses35),qs,"TRUE","");
                }
                if(j == 13){
                    giveResponse(List.of(arrayResponses36),qs,"FALSE","");
                }
                if(j == 14){
                    giveResponse(List.of(arrayResponses37),qs,"TRUE","");
                }
                if(j == 15){
                    giveResponse(List.of(arrayResponses38),qs,"TRUE","");
                }
                if(j == 16){
                    giveResponse(List.of(arrayResponses39),qs,"TRUE","");
                }
                if(j == 17){
                    giveResponse(List.of(arrayResponses40),qs,"TRUE","");
                }

                j++;
            }

        }

    }

    private void giveResponse(List<String>arrayResponses,Question qs,String responseToCompare,String comment){
        for(String r1 : arrayResponses){
            Response r = new Response();
            if((r1.trim().toLowerCase()).equals(responseToCompare.trim().toLowerCase())) {
                r.setResponse(r1);
                r.setIsCorrect(true);
                r.setQuestion(qs);
                r.setComment(comment);
            }else{
                r.setResponse(r1);
                r.setIsCorrect(false);
                r.setQuestion(qs);
                r.setComment("");
            }
            this.responseService.saveOrUpdateQuestion(r);
        }
    }


}
